Do not error out in the integration test cleanup function.
[arvados-workbench2.git] / tools / run-integration-tests.sh
1 #!/bin/bash
2 # Copyright (C) The Arvados Authors. All rights reserved.
3 #
4 # SPDX-License-Identifier: AGPL-3.0
5
6 set -e -o pipefail
7
8 cleanup() {
9     set -x
10     set +e +o pipefail
11     kill ${arvboot_PID} ${consume_stdout_PID} ${wb2_PID} ${consume_wb2_stdout_PID}
12     wait ${arvboot_PID} ${consume_stdout_PID} ${wb2_PID} ${consume_wb2_stdout_PID} || true
13     if [ "${CLEANUP_ARVADOS_DIR}" -eq "1" ]; then
14         rm -rf ${ARVADOS_DIR}
15     fi
16     echo >&2 "done"
17 }
18
19 random_free_port() {
20     while port=$(shuf -n1 -i $(cat /proc/sys/net/ipv4/ip_local_port_range | tr '\011' '-'))
21     netstat -atun | grep -q ":$port\s" ; do
22         continue
23     done
24     echo $port
25 }
26
27 usage() {
28     echo "Usage: ${0} [options]"
29     echo "Options:"
30     echo "  -i            Run Cypress in interactive mode."
31     echo "  -a PATH       Arvados dir. If PATH doesn't exist, a repo clone is downloaded there."
32     echo "  -w PATH       Workbench2 dir. Default: Current working directory"
33     exit 0
34 }
35
36 # Allow self-signed certs on 'wait-on'
37 export NODE_TLS_REJECT_UNAUTHORIZED=0
38
39 CLEANUP_ARVADOS_DIR=0
40 CYPRESS_MODE="run"
41 ARVADOS_DIR=`mktemp -d`
42 WB2_DIR=`pwd`
43
44 while getopts "ia:w:" o; do
45     case "${o}" in
46         i)
47             # Interactive mode
48             CYPRESS_MODE="open"
49             ;;
50         a)
51             ARVADOS_DIR=${OPTARG}
52             ;;
53         w)
54             WB2_DIR=${OPTARG}
55             ;;
56         *)
57             echo "Invalid Option: -$OPTARG" 1>&2
58             usage
59             ;;
60     esac
61 done
62 shift $((OPTIND-1))
63
64 ARVADOS_LOG=${ARVADOS_DIR}/arvados.log
65 ARVADOS_CONF=${WB2_DIR}/tools/arvados_config.yml
66
67 if [ ! -f "${WB2_DIR}/src/index.tsx" ]; then
68     echo "ERROR: '${WB2_DIR}' isn't workbench2's directory"
69     usage
70 fi
71
72 if [ ! -f ${ARVADOS_CONF} ]; then
73     echo "ERROR: Arvados config file ${ARVADOS_CONF} not found"
74     exit 1
75 fi
76
77 if [ -f "${WB2_DIR}/public/config.json" ]; then
78     echo "ERROR: Please move public/config.json file out of the way"
79     exit 1
80 fi
81
82 if [ ! -d "${ARVADOS_DIR}/.git" ]; then
83     mkdir -p ${ARVADOS_DIR} || exit 1
84     CLEANUP_ARVADOS_DIR=1
85     echo "Downloading arvados..."
86     git clone https://git.arvados.org/arvados.git ${ARVADOS_DIR} || exit 1
87 fi
88
89 echo "Building & installing arvados-server..."
90 cd ${ARVADOS_DIR}
91 go mod download || exit 1
92 cd cmd/arvados-server
93 go install
94 cd -
95
96 echo "Installing dev dependencies..."
97 ~/go/bin/arvados-server install -type test || exit 1
98
99 echo "Launching arvados in test mode..."
100 coproc arvboot (~/go/bin/arvados-server boot \
101     -type test \
102     -config ${ARVADOS_CONF} \
103     -own-temporary-database \
104     -timeout 20m 2> ${ARVADOS_LOG})
105 trap cleanup ERR EXIT
106
107 read controllerURL <&"${arvboot[0]}" || exit 1
108 echo "Arvados up and running at ${controllerURL}"
109 IFS='/' ; read -ra controllerHostPort <<< "${controllerURL}" ; unset IFS
110 controllerHostPort=${controllerHostPort[2]}
111
112 # Copy coproc's stdout to stderr, to ensure `arvados-server boot`
113 # doesn't get blocked trying to write stdout.
114 exec 7<&"${arvboot[0]}"; coproc consume_stdout (cat <&7 >&2)
115
116 cd ${WB2_DIR}
117 echo "Launching workbench2..."
118 WB2_PORT=`random_free_port`
119 coproc wb2 (PORT=${WB2_PORT} \
120     REACT_APP_ARVADOS_API_HOST=${controllerHostPort} \
121     yarn start)
122 exec 8<&"${wb2[0]}"; coproc consume_wb2_stdout (cat <&8 >&2)
123
124 # Wait for workbench2 to be up.
125 # Using https-get to avoid false positive 'ready' detection.
126 yarn run wait-on --timeout 300000 https-get://localhost:${WB2_PORT} || exit 1
127
128 echo "Running tests..."
129 CYPRESS_system_token=systemusertesttoken1234567890aoeuidhtnsqjkxbmwvzpy \
130     CYPRESS_controller_url=${controllerURL} \
131     CYPRESS_BASE_URL=https://localhost:${WB2_PORT} \
132     yarn run cypress ${CYPRESS_MODE}